diff --git a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
similarity index 57%
rename from src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
rename to src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index 847ef2194..957e4322e 100644
--- a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -1,10 +1,11 @@
-package net.minecraft.client.entity.fx;
+package net.minecraft.client.entity.particle;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -27,38 +28,38 @@ public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
     }
     private ParticleDispatcher(){
         Minecraft mc = Minecraft.getMinecraft(this);
-        addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityBubbleFX(world, x, y, z, motionX, motionY, motionZ, true));
-        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityNoteFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityPortalFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityExplodeFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.ORANGE));
-        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.BLUE));
-        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.SOUL));
-        addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityLavaFX(world, x, y, z));
-        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFootStepFX(mc.renderEngine, world, x, y, z));
-        addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new EntitySplashFX(world1, d, d1, d2, d3, d4, d5));
-        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX, 2.5f));
-        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
-        addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityItemFX(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
-        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityDiggingFX(world, x, y, z,motionX,motionY,motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).setParticleColor((int) x, (int) y, (int) z));
-        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySnowShovelFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityHeartFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, true));
+        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new SmokeParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new NoteParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new PortalParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ExplodeParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.ORANGE));
+        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.BLUE));
+        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.SOUL));
+        addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new LavaParticle(world, x, y, z));
+        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new FootstepParticle(mc.renderEngine, world, x, y, z));
+        addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new SplashParticle(world1, d, d1, d2, d3, d4, d5));
+        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new SmokeParticle(world, x, y, z, motionX, motionY, motionX, 2.5f));
+        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new RedstoneDustParticle(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
+        addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new BreakingItemParticle(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
+        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new TerrainParticle(world, x, y, z,motionX,motionY,motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
+        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new SnowShovelParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new HeartParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
             if (mc.gameSettings.slimeParticles.value){
-                return new EntitySlimeChunkFX(world, x, y, z, Item.slimeball);
+                return new SlimeChunkParticle(world, x, y, z, Items.SLIMEBALL);
             }
             return null;
         });
-        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.GREEN.getId()));
-        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.BLUE.getId()));
-        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.ORANGE.getId()));
-        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.RED.getId()));
-        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityArrowGoldenFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new FireflyParticle(world, x, y, z, motionX, motionY, motionX, FireflyClusterMob.FireflyColor.GREEN.getId()));
+        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new FireflyParticle(world, x, y, z, motionX, motionY, motionX, FireflyClusterMob.FireflyColor.BLUE.getId()));
+        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new FireflyParticle(world, x, y, z, motionX, motionY, motionX, FireflyClusterMob.FireflyColor.ORANGE.getId()));
+        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new FireflyParticle(world, x, y, z, motionX, motionY, motionX, FireflyClusterMob.FireflyColor.RED.getId()));
+        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new GoldenArrowParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ, data) -> {
             int id = world.getBlockId((int)x, (int)y, (int)z);
             if (id != 0){
-                return new EntityLeafFX(world, x, y, z, motionX, motionY, motionX).func_4041_a((int)x, (int)y, (int)z);
+                return new LeafParticle(world, x, y, z, motionX, motionY, motionX).init((int)x, (int)y, (int)z);
             }
             return null;
         });
diff --git a/src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java b/src/main/java/net/minecraft/client/entity/particle/ParticleLambda.java
similarity index 59%
rename from src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java
rename to src/main/java/net/minecraft/client/entity/particle/ParticleLambda.java
index c7307f955..6a2b1afb5 100644
--- a/src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleLambda.java
@@ -1,8 +1,8 @@
-package net.minecraft.client.entity.fx;
+package net.minecraft.client.entity.particle;
 
 import net.minecraft.core.world.World;
 
 @FunctionalInterface
 public interface ParticleLambda {
-    EntityFX newParticle(World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data);
+    Particle newParticle(World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data);
 }
diff --git a/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java b/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
new file mode 100644
index 000000000..c15436794
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
@@ -0,0 +1,67 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+
+public class PortalParticle extends Particle {
+    private float oSize;
+    private double xStart;
+    private double yStart;
+    private double zStart;
+
+    public PortalParticle(World world, double x, double y, double z, double xd, double yd, double zd)
+    {
+        super(world, x, y, z, xd, yd, zd);
+        this.xd = xd;
+        this.yd = yd;
+        this.zd = zd;
+        this.xStart = this.x = x;
+        this.yStart = this.y = y;
+        this.zStart = this.z = z;
+        float br = this.random.nextFloat() * 0.6F + 0.4F;
+        this.oSize = this.size = random.nextFloat() * 0.2F + 0.5F;
+        this.rCol = this.gCol = this.bCol = 1.0F * br;
+        this.gCol *= 0.3F;
+        this.rCol *= 0.9F;
+        this.lifetime = (int)(Math.random() * 10D) + 40;
+        this.noPhysics = true;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + (int)(Math.random() * 8D));
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float s = (age + partialTick) / lifetime;
+        s = 1.0F - s;
+        s *= s;
+        s = 1.0F - s;
+        this.size = this.oSize * s;
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public float getBrightness(float partialTick) {
+        float br = super.getBrightness(partialTick);
+        float pos = (float) this.age / (float) this.lifetime;
+        pos *= pos;
+        pos *= pos;
+        return br * (1.0F - pos) + pos;
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        float pos = this.age / (float) this.lifetime;
+        float a = pos;
+        pos = -pos + pos * pos * 2.0F;
+        pos = 1.0F - pos;
+        this.x = this.xStart + this.xd * pos;
+        this.y = this.yStart + this.yd * pos + (1.0F - a);
+        this.z = this.zStart + this.zd * pos;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java b/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java
new file mode 100644
index 000000000..7126d32d3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/RedstoneDustParticle.java
@@ -0,0 +1,108 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class RedstoneDustParticle extends Particle {
+    float oSize;
+    private int brightness;
+
+    public RedstoneDustParticle(World world, double x, double y, double z, float red, float green, float blue, int brightness) {
+        this(world, x, y, z, 1.0F, red, green, blue, brightness);
+    }
+
+    public RedstoneDustParticle(World world, double x, double y, double z, float scale, float red, float green, float blue, int brightness) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.brightness = -1;
+        if (brightness >= 0){
+            this.brightness = brightness;
+        }
+        this.xd *= 0.1D;
+        this.yd *= 0.1D;
+        this.zd *= 0.1D;
+        float n = (float)Math.random() * 0.4F + 0.6F;
+        this.rCol = ((float)(Math.random() * 0.2D) + 0.8F) * red * n;
+        this.gCol = ((float)(Math.random() * 0.2D) + 0.8F) * green * n;
+        this.bCol = ((float)(Math.random() * 0.2D) + 0.8F) * blue * n;
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (l < 0.0F) {
+            l = 0.0F;
+        }
+        if(l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        if (this.tex == null) return;
+
+        float u0 = (float) this.tex.getIconUMin();
+        float u2 = (float) this.tex.getSubIconU(1);
+        float v0 = (float) this.tex.getIconVMin();
+        float v2 = (float) this.tex.getSubIconV(1);
+        float r = 0.1F * this.size;
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - RedstoneDustParticle.xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - RedstoneDustParticle.yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - RedstoneDustParticle.zOff);
+        float br = 1f;
+        if(LightmapHelper.isLightmapEnabled()) {
+            int xTile = MathHelper.floor(this.x);
+            int yTile = MathHelper.floor(this.y);
+            int zTile = MathHelper.floor(this.z);
+            int lmc;
+            if (this.brightness >= 0) {
+                lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
+            } else {
+                lmc = getLightmapCoord(partialTick);
+            }
+            t.setLightmapCoord(lmc);
+        } else {
+            br = Math.max(getBrightness(partialTick), this.brightness / 15f);
+        }
+        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u2, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u0, v2);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (7 - ((this.age * 8) / this.lifetime));
+        if (val >= 0){
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.move(this.xd, this.yd, this.zd);
+        if(this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.96D;
+        this.yd *= 0.96D;
+        this.zd *= 0.96D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java b/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java
new file mode 100644
index 000000000..ecf458f3f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/SlimeChunkParticle.java
@@ -0,0 +1,51 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+
+// Referenced classes of package net.minecraft.src:
+//            EntityFX, Item, Block, Tessellator,
+//            World
+
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.world.World;
+
+public class SlimeChunkParticle extends Particle {
+    public SlimeChunkParticle(World world, double x, double y, double z, Item item) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.tex = ItemModelDispatcher.getInstance().getDispatch(item).getIcon(null, item.getDefaultStack());
+        this.gravity = 2;
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        this.size /= 2.0F;
+        this.lifetime = 50;
+    }
+
+    @Override
+	public int getParticleTexture() {
+        return 2;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
+        float u2 = (float) this.tex.getSubIconU(0.25f + this.uo / 4F);
+        float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
+        float v2 = (float) this.tex.getSubIconV(0.25f + this.uo / 4F);
+        float r = 0.1F * this.size;
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - SlimeChunkParticle.xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - SlimeChunkParticle.yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - SlimeChunkParticle.zOff);
+        float br = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+        	br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u2, v2);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java b/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java
new file mode 100644
index 000000000..a3eeaac7e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/SmokeParticle.java
@@ -0,0 +1,72 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+
+public class SmokeParticle extends Particle {
+    float oSize;
+
+    public SmokeParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        this(world, x, y, z, xa, ya, za, 1.0F);
+    }
+
+    public SmokeParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.1D;
+        this.yd *= 0.1D;
+        this.zd *= 0.1D;
+        this.xd += xa;
+        this.yd += ya;
+        this.zd += za;
+        this.rCol = this.gCol = this.bCol = (float) (Math.random() * 0.3D);
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (l < 0.0F) {
+            l = 0.0F;
+        }
+        if (l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+    public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (7 - ((this.age * 8) / this.lifetime));
+        if (val >= 0) {
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.yd += 0.004D;
+        this.move(this.xd, this.yd, this.zd);
+        if (this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.96D;
+        this.yd *= 0.96D;
+        this.zd *= 0.96D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java b/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java
new file mode 100644
index 000000000..fd46b2775
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/SnowShovelParticle.java
@@ -0,0 +1,70 @@
+package net.minecraft.client.entity.particle;
+
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+
+public class SnowShovelParticle extends Particle {
+    float oSize;
+
+    public SnowShovelParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        this(world, x, y, z, xa, ya, za, 1.0F);
+    }
+
+    public SnowShovelParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
+        super(world, x, y, z, xa, ya, za);
+        this.xd *= 0.1D;
+        this.yd *= 0.1D;
+        this.zd *= 0.1D;
+        this.xd += xa;
+        this.yd += ya;
+        this.zd += za;
+        this.rCol = this.gCol = this.bCol = 1.0F - (float)(Math.random() * 0.3D);
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if(l < 0.0F) {
+            l = 0.0F;
+        }
+        if(l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (7 - ((this.age * 8) / this.lifetime));
+        if (val >= 0) {
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.yd -= 0.03D;
+        this.move(this.xd, this.yd, this.zd);
+        this.xd *= 0.99D;
+        this.yd *= 0.99D;
+        this.zd *= 0.99D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/SplashParticle.java b/src/main/java/net/minecraft/client/entity/particle/SplashParticle.java
new file mode 100644
index 000000000..ca68ea9ef
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/SplashParticle.java
@@ -0,0 +1,15 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.core.world.World;
+
+public class SplashParticle extends WaterDropParticle {
+    public SplashParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        super(world, x, y, z);
+        this.gravity = 0.04F;
+        if (ya == 0.0D && (xa != 0.0D || za != 0.0D)) {
+            this.xd = xa;
+            this.yd = ya + 0.1D;
+            this.zd = za;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java b/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java
new file mode 100644
index 000000000..dd9252e5f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/TakeAnimationParticle.java
@@ -0,0 +1,69 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+import org.lwjgl.opengl.GL11;
+
+public class TakeAnimationParticle extends Particle {
+    private Entity item;
+    private Entity target;
+    private int life;
+    private int lifeTime;
+    private float yOffs;
+
+    public TakeAnimationParticle(World world, Entity item, Entity target, float scale) {
+        super(world, item.x, item.y, item.z, item.xd, item.yd, item.zd);
+        this.life = 0;
+        this.lifeTime = 0;
+        this.item = item;
+        this.target = target;
+        this.lifeTime = 3;
+        this.yOffs = scale;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float time = (this.life + partialTick) / this.lifeTime;
+        time *= time;
+        double xo = item.x;
+        double yo = item.y;
+        double zo = item.z;
+        double xt = target.xo + (target.x - target.xo) * (double) partialTick;
+        double yt = target.yo + (target.y - target.yo) * (double) partialTick + (double) yOffs;
+        double zt = target.zo + (target.z - target.zo) * (double) partialTick;
+        double xx = xo + (xt - xo) * time;
+        double yy = yo + (yt - yo) * time;
+        double zz = zo + (zt - zo) * time;
+        int xTile = MathHelper.floor(xx);
+        int yTile = MathHelper.floor(yy + (double)(this.heightOffset / 2.0F));
+        int zTile = MathHelper.floor(zz);
+        xx -= TakeAnimationParticle.xOff;
+        yy -= TakeAnimationParticle.yOff;
+        zz -= TakeAnimationParticle.zOff;
+        float br = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	LightmapHelper.setLightmapCoord(this.item.world.getLightmapCoord(xTile, yTile, zTile, 0));
+        }else {
+        	br = this.world.getLightBrightness(xTile, yTile, zTile);
+        }
+        GL11.glColor4f(br, br, br, 1.0F);
+        EntityRenderDispatcher.instance.renderEntityWithPosYaw(t, this.item, (float)xx, (float)yy, (float)zz, this.item.yRot, partialTick);
+    }
+
+    @Override
+	public void tick() {
+        this.life++;
+        if (this.life == this.lifeTime) {
+            remove();
+        }
+    }
+
+    @Override
+	public int getParticleTexture() {
+        return 3;
+    }
+}
